/*
 * smsform.java
 *
 * Created on 18 February 2007, 13:40
 */

package smsreader;

import gnu.io.CommPortIdentifier;
import gnu.io.NoSuchPortException;
import gnu.io.PortInUseException;
import gnu.io.SerialPort;
import gnu.io.SerialPortEvent;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.OutputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.PrintStream;
import java.io.File;
import java.io.FileOutputStream;
import java.util.Timer;
import javax.swing.ImageIcon;

/**
 *
 * @author  jnutbroek
 */
public class smsform extends javax.swing.JFrame {
    
    // Variables for serialport communication
    private SerialPort serialPort;
    private CommPortIdentifier commPortId; 
    BufferedReader inStream = null;
    PrintStream outStream = null;  
    
    // Variables for SMS communiction
    boolean communicating = false; 
    int total_sms=0;
    long uptime_smsclient=System.currentTimeMillis();
    
    // Booleans for animation
    boolean blink=false;
    boolean error=false;  
    
    /** Creates new form smsform */
    public smsform() {
        initComponents();
        
        // Add custom application icon
        ImageIcon app_icon = new ImageIcon(getClass().getResource("/images/icon.gif"));
        setIconImage(app_icon.getImage());
        
        // Center window 
        Toolkit kit = Toolkit.getDefaultToolkit();
        Dimension screenSize = kit.getScreenSize();
        int screenHeight = screenSize.height;
        int screenWidth = screenSize.width;
        this.setLocation((screenWidth-this.getWidth())/2,(screenHeight-this.getHeight())/2);
        
        // Start SMS Reader
        javax.swing.Timer rs232_timer = new javax.swing.Timer(10000, new rs232());
        rs232_timer.start();         
        
        // Start throbber timer
        animationred.setBackground(Color.LIGHT_GRAY);
        animationgreen.setBackground(Color.LIGHT_GRAY);
        javax.swing.Timer animation_timer = new javax.swing.Timer(500, new animation());
        animation_timer.start();          
    }

    class rs232 implements ActionListener {
        public void actionPerformed(ActionEvent e) { 
            try {
                if (!communicating) {
                    System.gc();
                    (new read_SMS()).start();
                }
            } catch (Exception er) {}            
        }
    }  
    
    class animation implements ActionListener {
        public void actionPerformed(ActionEvent e) {
                try {
                    if (blink) {
                        animationgreen.setBackground(Color.GREEN);
                        animationred.setBackground(Color.LIGHT_GRAY);
                        blink=false;
                    } else {
                        animationgreen.setBackground(Color.LIGHT_GRAY);
                        if (error) {animationred.setBackground(Color.RED);}                                 
                        blink=true;                                    
                    }                    
                } catch (Exception er) {}            
        }
    }    
    
    public void initializeCOM() {
        closeCOM();
        try {
            commPortId = CommPortIdentifier.getPortIdentifier("COM" + comport.getText().toString());
            serialPort = (SerialPort)commPortId.open("COM" + comport.getText().toString(),0);
            serialPort.setSerialPortParams(9600,SerialPort.DATABITS_8,SerialPort.STOPBITS_1,SerialPort.PARITY_NONE); 
            serialPort.setFlowControlMode(SerialPort.FLOWCONTROL_NONE);
            try {
                inStream = new BufferedReader(new InputStreamReader(serialPort.getInputStream()));
            } catch (IOException e) {
                inStream = null;
            }
            if (inStream == null) {
                throw new NoSuchPortException();
            } else {
                outStream = new PrintStream(serialPort.getOutputStream(), true);            
            }           
        } catch (PortInUseException e) {
            updatemessage("Error: Port " + "COM" + comport.getText().toString() + " already in use");
            error=true;
            closeCOM();
        } catch (NoSuchPortException e) {
            updatemessage("Error: Port " + "COM" + comport.getText().toString() + " does not exist");
            error=true;
            closeCOM();
        } catch (Exception e) { 
            updatemessage("RS232 communication error");
            error=true;
            closeCOM();
        } finally {
            this.setTitle("SMS Reader - Version 1.0.2");
            error=false;
            communicating=false;
            animationgreen.setBackground(Color.GREEN);
            animationred.setBackground(Color.LIGHT_GRAY);            
        }           
    }
    
    public void closeCOM() {
        try {
            if (inStream != null)
                inStream.close();
            if (outStream != null)
                outStream.close();
            if (serialPort != null)
                serialPort.close();            
        } catch (IOException e) {}
        inStream = null;
        outStream = null;
        serialPort = null;
        commPortId = null;        
    }
    
    public class kill_rs232session extends Thread {
        Thread threadToInterrupt = null;
        public kill_rs232session() {
            threadToInterrupt = Thread.currentThread();
            setDaemon(true);
        }
        public void run() {
            try {
                Thread.currentThread().sleep(20000);
            } catch(InterruptedException ex) {}
            threadToInterrupt.interrupt();
            threadToInterrupt = null;
            communicating=false;
            updatemessage("RS232 communication interrupted");
        }
    }
    
    public class read_SMS extends Thread {
        public void run() {
        communicating=true;
        (new kill_rs232session()).start();
        long timer=System.currentTimeMillis();
        boolean accept_sms=false;
        int sim_location=0;
        String reply=""; 
        String validnumber="";
        String smsdata="";
        String smsfilename="";
        String valid=phonenumbers.getText().toString() + ",1234567890";
        String[] validnumbers = valid.split(",");
        String separator_required="";
        if (!localpath.getText().toString().endsWith(File.separator)) {separator_required=File.separator;}
        message.setText(""); 
        outStream.print("AT+CMGL=\"REC UNREAD\"");
        outStream.print("\r\n");        
        while ((System.currentTimeMillis()-timer)<10000 && !reply.equals("OK") && !reply.equals("ERROR") && !reply.equals("0") && !reply.equals("4")) {
            try {
                while (!inStream.ready() && (System.currentTimeMillis()-timer)<2000) {
                    try {Thread.sleep(100);} catch (InterruptedException e) {}
                }
            } catch (Exception e) {error=true;}
            try {
                if (inStream.ready()) {
                    reply = inStream.readLine().toString();
                    if (!reply.equals("")) {
                        if (reply.contains("+CMGL:")) {
                            String sms_sender[] = reply.toString().split(",");
                            validnumber=sms_sender[2].replace("\"","").trim();
                            validnumber=validnumber.replace("+","");
                            sim_location=Integer.parseInt(sms_sender[0].replace("+CMGL:","").trim());
                        }                        
                        if (!reply.contains("+CMGL:") && reply.length()>10) {
                            smsdata=reply.toString();  
                            accept_sms=false;
                            for (int i=0; i<validnumbers.length; i++) {
                                if (validnumber.equals(new String(validnumbers[i]))) {
                                    accept_sms=true;
                                    smsfilename=validnumbers[i].toString();
                                }
                            }
                            if (accept_sms) {
                                updatemessage("Received SMS from: " + validnumber);
                                updatemessage("Stored in SIM location: " + sim_location);
                                updatemessage("Data:");
                                updatemessage("" + smsdata);
                                updatemessage("Writing SMS data to file: " + smsfilename + ".txt");
                                OutputStream smsout=new FileOutputStream(localpath.getText().toString() + separator_required + smsfilename + ".txt",true);
                                smsout.write(smsdata.toString().getBytes());
                                smsout.write(0x0D);
                                smsout.write(0x0A);
                                smsout.close();
                                smsout.flush();
                                smsout = null;
                                total_sms++;
                            }                               
                        }
                    }  
                }
            } catch (Exception e) {error=true;}
        }
        if (sim_location>0) {
            for (int i=1; i<(sim_location+1); i++) {
                outStream.print("AT+CMGD=" + i);
                outStream.print("\r\n");
                reply="";
                timer=System.currentTimeMillis();
                while ((System.currentTimeMillis()-timer)<5000 && !reply.equals("OK") && !reply.equals("ERROR") && !reply.equals("0") && !reply.equals("4")) {
                    try {
                        while (!inStream.ready() && (System.currentTimeMillis()-timer)<2000) {
                            try {Thread.sleep(100);} catch (InterruptedException e) {}
                        }
                    } catch (Exception e) {error=true;}
                    try {
                        if (inStream.ready()) {
                            reply = inStream.readLine().toString();
                            if (reply.equals("OK") || reply.equals("ERROR") || reply.equals("0") || reply.equals("4")) {
                                updatemessage("Deleting message at SIM location: " + i);
                                updatemessage("Response: " + reply.toString());
                            }
                        }
                    } catch (Exception e) {error=true;}
                }
            }
        }
        updatemessage("Total SMS data messages accepted: " + total_sms);
        int min=(int) (((System.currentTimeMillis()-uptime_smsclient)/1000)/60);
        int hrs=(int) (min/60);
        int days=(int) (hrs/24);
        min=min-(hrs*60);
        hrs=hrs-(days*24);
        updatemessage("Uptime: " + days + " days " + hrs + " hr and " + min + " min");
        communicating=false;
        }
    }    
     
    public void updatemessage(String text) {
        message.append(">" + text);
        message.append("\r");
        message.append("\n");
        message.setCaretPosition(message.getDocument().getLength());
    }  
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jPanel1 = new javax.swing.JPanel();
        jLabel5 = new javax.swing.JLabel();
        comport = new javax.swing.JTextField();
        up = new javax.swing.JButton();
        down = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        message = new javax.swing.JTextArea();
        jLabel6 = new javax.swing.JLabel();
        phonenumbers = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        localpath = new javax.swing.JTextField();
        animationgreen = new javax.swing.JLabel();
        animationred = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("SMS Reader Initializing...");
        setResizable(false);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
            public void windowOpened(java.awt.event.WindowEvent evt) {
                formWindowOpened(evt);
            }
        });

        jLabel5.setText("COM port");

        comport.setEditable(false);
        comport.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        comport.setText("1");
        comport.setToolTipText("Number of the COM port");

        up.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/up.gif")));
        up.setToolTipText("up");
        up.setBorder(null);
        up.setBorderPainted(false);
        up.setContentAreaFilled(false);
        up.setFocusPainted(false);
        up.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                upActionPerformed(evt);
            }
        });

        down.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/down.gif")));
        down.setToolTipText("down");
        down.setBorder(null);
        down.setBorderPainted(false);
        down.setContentAreaFilled(false);
        down.setFocusPainted(false);
        down.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                downActionPerformed(evt);
            }
        });

        jScrollPane1.setHorizontalScrollBarPolicy(javax.swing.ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
        jScrollPane1.setVerticalScrollBarPolicy(javax.swing.ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
        jScrollPane1.setMaximumSize(new java.awt.Dimension(320, 250));
        jScrollPane1.setMinimumSize(new java.awt.Dimension(320, 250));
        message.setBackground(new java.awt.Color(0, 0, 0));
        message.setFont(new java.awt.Font("Dialog", 0, 10));
        message.setForeground(new java.awt.Color(255, 255, 255));
        message.setLineWrap(true);
        message.setToolTipText("");
        message.setAutoscrolls(false);
        message.setDisabledTextColor(new java.awt.Color(255, 255, 255));
        message.setEnabled(false);
        message.setMaximumSize(new java.awt.Dimension(280, 250));
        message.setMinimumSize(new java.awt.Dimension(280, 250));
        jScrollPane1.setViewportView(message);

        jLabel6.setText("Accept SMS from:");

        phonenumbers.setToolTipText("Enter the GSM phonenumbers comma separated from valid incoming SMS");

        jLabel7.setText("Local directory:");

        localpath.setToolTipText("SMS messages will be saved to the local path entered here");

        animationgreen.setFont(new java.awt.Font("Tahoma", 0, 10));
        animationgreen.setForeground(java.awt.Color.lightGray);
        animationgreen.setToolTipText("status: OK");
        animationgreen.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        animationgreen.setEnabled(false);
        animationgreen.setMaximumSize(new java.awt.Dimension(10, 10));
        animationgreen.setMinimumSize(new java.awt.Dimension(10, 10));
        animationgreen.setOpaque(true);
        animationgreen.setPreferredSize(new java.awt.Dimension(10, 10));

        animationred.setFont(new java.awt.Font("Tahoma", 0, 10));
        animationred.setForeground(java.awt.Color.lightGray);
        animationred.setToolTipText("stats: error - check logfile for details");
        animationred.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        animationred.setMaximumSize(new java.awt.Dimension(10, 10));
        animationred.setMinimumSize(new java.awt.Dimension(10, 10));
        animationred.setOpaque(true);
        animationred.setPreferredSize(new java.awt.Dimension(10, 10));

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel1Layout.createSequentialGroup()
                        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jPanel1Layout.createSequentialGroup()
                                .add(jLabel5)
                                .add(12, 12, 12)
                                .add(comport, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 43, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                            .add(jLabel6, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 102, Short.MAX_VALUE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(phonenumbers, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 301, Short.MAX_VALUE)
                            .add(jPanel1Layout.createSequentialGroup()
                                .add(1, 1, 1)
                                .add(up, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 16, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .add(0, 0, 0)
                                .add(down, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 16, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 248, Short.MAX_VALUE)
                                .add(animationgreen, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .add(0, 0, 0)
                                .add(animationred, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))))
                    .add(jPanel1Layout.createSequentialGroup()
                        .add(jLabel7, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 102, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .add(localpath, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 301, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 407, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                        .add(jLabel5)
                        .add(comport, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(up)
                        .add(down))
                    .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                        .add(animationred, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(animationgreen, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(phonenumbers, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel6))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel7)
                    .add(localpath, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 150, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void formWindowOpened(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowOpened
        File inFile  = new File("configuration.txt");
        try {
            BufferedReader reader = new BufferedReader(new FileReader(inFile));
            comport.setText(reader.readLine());
            phonenumbers.setText(reader.readLine());
            localpath.setText(reader.readLine());
            reader.close();
            reader = null;
        } catch (Exception e) {error=true;}
        initializeCOM();      
        message.setText("");        
    }//GEN-LAST:event_formWindowOpened

    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
        File outFile = new File("configuration.txt");
        try {
            BufferedWriter writer = new BufferedWriter(new FileWriter(outFile));
            writer.write(comport.getText().toString());
            writer.newLine();
            writer.write(phonenumbers.getText().toString());
            writer.newLine();
            writer.write(localpath.getText().toString());
            writer.newLine();
            writer.close();
            writer.flush();
            writer = null;
        } catch (Exception e) {error=true;}
        closeCOM();
    }//GEN-LAST:event_formWindowClosing

    private void downActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_downActionPerformed
        comport.setText("" + (Integer.parseInt(comport.getText())-1));
        if (Integer.parseInt(comport.getText())<1)
            comport.setText("1");
        message.setText("");
        initializeCOM();
    }//GEN-LAST:event_downActionPerformed

    private void upActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_upActionPerformed
        comport.setText("" + (Integer.parseInt(comport.getText())+1));
        message.setText("");
        initializeCOM();
    }//GEN-LAST:event_upActionPerformed
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new smsform().setVisible(true);
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel animationgreen;
    private javax.swing.JLabel animationred;
    private javax.swing.JTextField comport;
    private javax.swing.JButton down;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextField localpath;
    private javax.swing.JTextArea message;
    private javax.swing.JTextField phonenumbers;
    private javax.swing.JButton up;
    // End of variables declaration//GEN-END:variables
    
}
